﻿Imports System.Text

Public Class Form1

    Dim creation As MyCreation

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim ds As DataSet = New DataSet

        Dim a As DataTable = New DataTable
        a.Columns.Add("ID", GetType(Integer)).AutoIncrement = True
        a.Columns.Add("Name", GetType(String))

        Dim b As DataTable = New DataTable
        b.Columns.Add("ID", GetType(Integer)).AutoIncrement = True
        b.Columns.Add("PID", GetType(Integer))
        b.Columns.Add("Name", GetType(String))

        For index = 1 To 5

            AddToChild(a.Rows.Add(Nothing, String.Format("Name{0}", index)), b, index)
        Next

        ds.Tables.Add(a)
        ds.Tables.Add(b)
        ds.Relations.Add(a.Columns("ID"), b.Columns("PID"))

        UltraGrid1.DataSource = ds
        creation = New MyCreation(UltraGrid1.DisplayLayout.Bands(1).Columns("Name"))
        AddHandler creation.OnAfterCellCreated, AddressOf Me.AfterCellCreated

        UltraGrid1.CreationFilter = creation

    End Sub

    Private Function AddToChild(dataRow As DataRow, b As DataTable, index As Integer) As Integer
        Dim sb As StringBuilder = New StringBuilder
        sb.Append(dataRow("Name"))
        For i = 1 To index
            sb.Append(String.Format("Child"))
            b.Rows.Add(Nothing, dataRow("ID"), sb.ToString())
            sb.Append(String.Format("Child"))
        Next
        Return 0

    End Function


    Private Sub AfterCellCreated(sender As Object, e As CellCreatedArgs)
        e.Cell.Column.PerformAutoResize(Infragistics.Win.UltraWinGrid.PerformAutoSizeType.VisibleRows)

    End Sub

   
End Class
